import { _decorator, Camera, Component, ERaycast2DType, EventTouch, Input, input, Node, PhysicsSystem2D, v3, Vec3 } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('PhysicsController')
export class PhysicsController extends Component {
    private static readonly phyWallGroup = 1 << 2;

    @property(Node)
    public enemyNode: Node = null;
    @property(Camera)
    public mainCamera: Camera = null;

    start() {
        this.registerEvent();
    }

    private registerEvent() {
        input.on(Input.EventType.TOUCH_START, this.onTouchStart, this);
    }

    private onTouchStart(event: EventTouch) {
        let position = event.getLocation();
        let worldPosition: Vec3 = v3();
        this.mainCamera.camera.screenToWorld(worldPosition, v3(position.x, position.y));
        let result = PhysicsSystem2D.instance.raycast(worldPosition, this.enemyNode.worldPosition, ERaycast2DType.All, PhysicsController.phyWallGroup);
        console.log("点击位置到怪物的检测结果", result);
        result = PhysicsSystem2D.instance.raycast(this.enemyNode.worldPosition, worldPosition, ERaycast2DType.All, PhysicsController.phyWallGroup);
        console.log("怪物到点击位置的检测结果", result);
    }
}


